(test-group
  (let* ((var 'val)
         (var2 'val2))
    (and (eq? var 'val) (eq? var2 'val2)))
  ;; Unlike let, let* makes each binding visible
  ;; in the following bindings.
  (let ((var 'first-val))
    (let* ((var 'second-val)
           (var2 var))
      (eq? var2 'second-val)))
  ;; However, a variable is not visible during its own binding.
  (let ((var 'first-val))
    (let ((var (lambda () var)))
      (eq? (var) 'first-val)))
  ;; let* accepts zero bindings
  (let* ()
    #t)
)
