(test-group
  (let ((var 'val))
    (eq? 'val var))
  (let ((var1 'val1)
        (var2 'val2))
    (and (eq? var1 'val1)
         (eq? var2 'val2)))
  ;; The binding of a variable is not visible when
  ;; evaluating the expressions assigned to later variables.
  (let ((var 'first-val))
    (let ((var 'second-val)
          (var2 var))
      (eq? var2 'first-val)))
  ;; It is not even visible when evaluating the binding
  ;; for that very variable.
  (let ((var 'first-val))
    (let ((var (lambda () var)))
      (eq? (var) 'first-val)))
  ;; let accepts several expressions.
  (let ((var 'first-val))
    (set! var 'second-val)
    (eq? var 'second-val))
  ;; Test named let
  (let loop ((lst '(1 2 3 4))
             (acc '()))
    (if (null? lst)
        (equal? acc '(4 3 2 1))
        (loop (cdr lst) (cons (car lst) acc))))
  ;; Having no variables is valid (`let` is like `begin` then).
  (let ()
    #t)
  (let loop ()
    #t)
)
