(test-group
  ;; literal matching
  (syntax-case 5 ()
    (5 #t)
    (_ #f))
  (syntax-case 6 ()
    (5 #f)
    (_ #t))

  ;; wildcard
  (syntax-case 5 ()
    (_ #t))

  ;; Test that the wildcard doesn't bind a pattern variable.
  (free-identifier=?
   #'_
   (syntax-case 5 ()
     (_ #'_)))

  ;; Test some other constants
  (syntax-case 5.0 ()
    (5.0 #t)
    (_ #f))

  (syntax-case 5.0 ()
    (6.0 #f)
    (_ #t))

  (syntax-case #t ()
    (#f #f)
    (#t #t))

  (syntax-case #f ()
    (#f #t)
    (_ #f))

  (syntax-case '() ()
    (() #t)
    (_ #f))

  (syntax-case "string" ()
    ("string" #t)
    (_ #f))

  (syntax-case "string" ()
    ("other-string" #f)
    (5 #f)
    (_ #t))

  (syntax-case '(1 . 2) ()
    ((1 . 2) #t)
    (_ #f))

  (syntax-case '(1 . 2) ()
    ((1 . 3) #f)
    (_ #t))

  ;; Test that clauses are tried in order
  (syntax-case 5 ()
    (0 #f)
    (5 #t)
    (5 #f)
    (5 #f))

  ;; Test fenders
  (syntax-case 5 ()
    (5 #f #f)
    (5 #t))

  (syntax-case 5 ()
    (5 #t #t)
    (_ #f))

  ;; Test simple pattern variables (in fender and body)
  (syntax-case #'foo ()
    (x (identifier? #'x) #t)
    (_ #f))

  (syntax-case '((1 2 3) . (4 5 6)) ()
    ((x . y)
     (and (equal? #'x '(1 2 3))
          (equal? #'y '(4 5 6)))))

  ;; Test ellipses
  (syntax-case '(1 2 3 4) ()
    ((x ...)
     (equal? '(1 2 3 4) #'(x ...))))

  (syntax-case 42 ()
    ((x ...) #f)
    (_ #t))

  (syntax-case '((1 2 3 4) 5 6 7 8) ()
    (((x ...) y ...)
     (and (equal? '(1 2 3 4) #'(x ...))
          (equal? '(5 6 7 8) #'(y ...))
          (equal? '((1 . 5) (2 . 6) (3 . 7) (4 . 8))
                  #'((x . y) ...)))))

  ;; Test arbitrary patterns in ellipses
  (syntax-case '(((0 1) (0 2) (0 3)) ((1 4) (1 5) (1 6))) ()
    ((((0 x) ...) ((1 y) ...))
     (equal? '((1 . 4) (2 . 5) (3 . 6))
             #'((x . y) ...))))

  ;; Test nested patterns
  (syntax-case '(((0 1) (0 2) (0 3)) ((0 4) (0 5) (0 6))) ()
    ((((0 x) ...) ...)
     (equal? '((1 2 3) (4 5 6))
             #'((x ...) ...))))

)