(test-group
  ;; constants
  (eqv? 1 #'1)
  (eqv? 1.0 #'1.0)
  (eqv? #t #'#t)
  (eqv? #f #'#f)
  (eq? '() #'())
  (equal? "string" #'"string")
  (eq? 'sym (syntax->datum #'sym))
  ;; pattern variables
  (with-syntax ((var #'val))
    (eq? 'val (syntax->datum #'var)))
  (with-syntax (((var ...) '(1 2 3 4)))
    (equal? '(1 2 3 4) #'(var ...)))
  (with-syntax ((((var val) ...) '((0 1) (2 3) (4 5))))
    (equal? '((0 2 4) (1 3 5)) #'((var ...) (val ...))))
  (with-syntax ((((var ...) (val ...) ...)
                 '((0 1 2) (3 4 5) (6 7 8))))
    (equal? '(((0 3) (1 4) (2 5)) ((0 6) (1 7) (2 8)))
            #'(((var val) ...) ...)))
  (with-syntax ((((var1 ...) ((var2 ...) ...) (((var3 ...) ...) ...))
                 '((i j)
                   ((a1 b1) (a2 b2) (a3 b3))
                   (((x1 x2) (y1 y2) (z1 z2)) ((u1 u2) (v1 v2) (w1 w2))))))
    (equal? #'((((var1 var2 var3) ...) ...) ...)
            '((((i a1 x1) (j b1 x2)) ((i a2 y1) (j b2 y2)) ((i a3 z1) (j b3 z2)))
              (((i a1 u1) (j b1 u2)) ((i a2 v1) (j b2 v2)) ((i a3 w1) (j b3 w2))))))
  ;; mixing the two
  (with-syntax (((var ...) '(0 1 2 3)))
    (equal? #'((#f var) ...)
            '((#f 0) (#f 1) (#f 2) (#f 3))))
)
