;; A macro that introduces a `cond` form with an `else`
;; form, hygienically.
(define-syntax introduce-cond/hygienic
  (syntax-rules ()
    ((introduce-cond/hygienic)
     (cond (else 'foo)))))

;; Same macro, but the `else` is purposefully unhygienic.
(define-syntax introduce-cond/unhygienic    
  (lambda (sintax)
    (syntax-case sintax ()
      ((introduce-cond/unhygienic)
       (with-syntax ((else-kwd (datum->syntax #'introduce-cond/unhygienic 'else)))
         #'(cond (else-kwd 'foo)))))))

(test-group
  (eq? 'foo (introduce-cond/hygienic))
  (eq? 'foo (let ((else #f)) (introduce-cond/hygienic)))
  (eq? 'foo (introduce-cond/unhygienic))
  (unspecified? (let ((else #f)) (introduce-cond/unhygienic))))
